from StringIO import StringIO
from Products.CMFCore import utils as cmfutils
from Products.CMFCore import permissions as cmfperms

UPLOAD_ACTION = { 'id': 'folderflashupload',
                  'name': 'Upload',
                  'action': 'string:${globals_view/getCurrentFolderUrl}/flashupload',
                  'condition': 'object/display_upload',
                  'permission': cmfperms.AddPortalContent,
                  'category': 'object', # to show up as a content tab
                  'visible': 1 }

CONFIGLET_ACTION = { 'id': 'flashuploadconfiglet',
                     'name': 'Flash Upload',
                     'action': 'string:$portal_url/flashupload-configlet.html',
                     'condition': '',
                     'permission': cmfperms.ManagePortal,
                     'category': 'Products',
                     'visible': 1 }

def _setup_action(out, tool, actiondict, install=True):

    existing = None
    existing_index = -1
    for index, info in enumerate(tool.listActions()):
        if info.getId() == actiondict['id']:
            existing = info
            existing_index = index
            break

    if install:
        if existing is None:
            tool.addAction(**actiondict)
            print >> out, 'Added new object action, "%s"' % actiondict['id']
        elif existing is not None:
            print >> out, '"%s" object action already exists, no need to add' \
                  % actiondict['id']
    else:
        if existing is None:
            print >> out, '"%s" object action not installed, no removal ' \
                  'necessary' % actiondict['id']

        elif existing is not None:
            tool.deleteActions([existing_index])
            print >> out, 'Removed "%s" object action' % actiondict['id']

def setup_actions(portal, out, install=True):
    _setup_action(out,
                  cmfutils.getToolByName(portal, 'portal_actions'),
                  UPLOAD_ACTION, install)
    _setup_action(out,
                  cmfutils.getToolByName(portal, 'portal_controlpanel'),
                  CONFIGLET_ACTION, install)

def install(self):
    out = StringIO()

    setup_actions(self, out)

    return out.getvalue()

def uninstall(self):
    out = StringIO()

    setup_actions(self, out, install=False)

    return out.getvalue()
